package ru.mai.dep806.javasample;

import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: Eugene
 * Date: 27.10.11
 * Time: 19:53
 * To change this template use File | Settings | File Templates.
 */
public class AnimalMain {

    public static void main(String[] args) {
        Animal[] animals = new Animal[] {new Bear(), new Hedgehog()};

        for (Animal animal : animals) {
            animal.eat(new Meat());
        }

        Collection<Bear> animalsSet = new TreeSet<Bear>(new AgeComparator());

        for (Iterator<Bear> iterator = animalsSet.iterator(); iterator.hasNext(); ) {
            Bear next =  iterator.next();
            System.out.println(next);
        }

        Collections.sort(new ArrayList<Bear>(), new AgeComparator());

    }

    private static class AgeComparator implements Comparator<Bear> {
        @Override
        public int compare(Bear o1, Bear o2) {
            if (o1.age > o2.age) return 1;
            if (o1.age < o2.age) return -1;
            return o1.name.compareTo(o2.name);
        }
    }
}
